(in-package :cl-user)
(defpackage "EVENT"
  (:export add-fd-handler remove-fd-handler read-n-bytes)
  (:shadowing-import-from #+cmu MOP #+sbcl SB-PCL
                          class-of)
  (:shadowing-import-from #+cmu SYSTEM #+sbcl SB-SYS
			  add-fd-handler
			  remove-fd-handler
			  read-n-bytes	; XXX questionable
			  ))
  
(defpackage "ARANEIDA"
  (:nicknames "HTTP-SERVER" "HTTPSRV")
  (:export
   ;; daemon
   install-serve-event-handlers remove-serve-event-handlers
   ;; define-page
   define-page
   ;; exports
   export-server export-handler output-apache-conf
   ;; file-request
   *content-types* file-request-handler
   ;; html
   html html-escape html-stream
   ;; pattern-match
   define-patterns rewrite-tree
   ;; server
   server-base-url export-server server
   ;; request
   request request-url request-original-url request-method
   request-socket request-stream request-session request-headers
   request-body request-base-url request-path-info request-header
   request-condition
   request-send-headers request-send-error request-redirect   
   body-param body-params request-if-modified-since
   dispatch-request
   ;; url
   url url-scheme copy-url internet-url url-username url-password
   url-host url-port url-path url-query url-fragment urlstring
   urlstring-unescape
   http-url https-url httplike-url urlstring-escape  url-query-alist
   parse-urlstring make-url merge-url url-query-param)

  ;; either we have to write a COPY-URL method for every new URL class,
  ;; or we use the MOP.  The former would actually have been a better idea
  ;; (I'm taking patches ...)
  (:shadowing-import-from #+cmu MOP #+sbcl SB-PCL
                          CLASS-NAME BUILT-IN-CLASS CLASS-OF FIND-CLASS)
  (:use #+cmu "MOP"  "COMMON-LISP" ))

